import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
import javax.swing.JOptionPane;
import java.net.*;

public class SudokuGame
{	
	public Number[][] numbers = new Number[9][9];
	public ArrayList<Integer>[][] quadrants = new ArrayList[3][3];
	public ArrayList<Integer>[] rows = new ArrayList[9];
	public ArrayList<Integer>[] columns = new ArrayList[9];
	public int overflow = 0;
	public SudokuGame()
	{
		makeGame();
	}
	
	
	public void makeGame()
	{
		for (int i = 0; i < 3; i++)
		{
			for (int j = 0; j < 3; j++)
			{
				quadrants[j][i] = new ArrayList();
				for (int q = 1; q < 10; q++)
					quadrants[j][i].add(q); 
			}
		}
		
		for (int i = 0; i < 9; i++)
		{
				rows[i] = new ArrayList();
				columns[i] = new ArrayList();
				for (int q = 1; q < 10; q++)
				{
					rows[i].add(q);
					columns[i].add(q);
				}
		}
		
		for (int i = 0; i < 9; i++)
		{
			doRow(i);
		}
		
	}
	
	public void doRow(int i)
	{
			int num;	
			ArrayList<Integer> nums = new ArrayList();
			for (int j = 0; j < 9; j++)
			{

				num = getNum(j,i);
				if(num==0)
				{
					ArrayList<Integer> quadrant;
					ArrayList<Integer> column;
					ArrayList<Integer> row;
						
					for (int q = 0; q < j; q++)
					{
						int quadx, quady;
						quadx = q/3;
						quady = i/3;
						quadrant = quadrants[quadx][quady];
						column = columns[q];
						row = rows[i];
						quadrant.add(nums.get(q));
						column.add(nums.get(q));
						row.add(nums.get(q));		
					}
					if(overflow <= 400)
					{
						overflow++;
						doRow(i);
						return;
					}
					else
					{	
						overflow = 0;
						makeGame();
						return;
					}
				}
				else
				{
				nums.add(num);					
				if ((j+1)%3 == 0 && (i+1)%3==0)	
					{
						numbers[j][i] = new Number(num, 2);
					}
				else 
					if ((i+1)%3 == 0)
					{
						numbers[j][i] = new Number(num , 1);
					}
				else
				   if (((j+1)%3)==0)
					{
						numbers[j][i] = new Number(num , 0);
					}	
				else
					{
						numbers[j][i] = new Number(num);
					}
				}
			}
	}
	
	public int getNum(int x, int y)
	{
		Random rand = new Random();
		int quadx, quady;
		quadx = x/3;
		quady = y/3;
		ArrayList<Integer> quadrant = quadrants[quadx][quady];
		ArrayList<Integer> column = columns[x];
		ArrayList<Integer> row = rows[y];
		ArrayList<Integer> columnNumbers, rowNumbers, numbers;
		numbers = new ArrayList(quadrant);
		columnNumbers = column;
		rowNumbers = row;
		
		numbers.retainAll(columnNumbers);
		numbers.retainAll(rowNumbers);
		if (numbers.size() > 0)
		{	
			Integer numb = numbers.get(rand.nextInt(numbers.size()));
			row.remove(row.indexOf(numb));
			column.remove(column.indexOf(numb));
			quadrant.remove(quadrant.indexOf(numb));
			return numb;
		}
		else
			return 0;
	}
	
	public void removeNum(int x, int y, int num)
	{
		int quadx, quady;
		quadx = x/3;
		quady = y/3;
		ArrayList<Integer> quadrant = quadrants[quadx][quady];
		ArrayList<Integer> column = columns[x];
		ArrayList<Integer> row = rows[y];
		//row.gotNum(num);
		//column.gotNum(num);
		//quadrant.remove(num);
	}
	
	public Number[][] getNumbers()
	{
		return numbers;		
	}
	
	public boolean canPutNumber(int num, int x, int y)
	{
		return true;
	}

	private class Column
		{
		private ArrayList<Integer> nums = new ArrayList();
		
		public Column()
		{
			for (int i = 1; i < 10;i++)
				nums.add(i); 
		}
		public ArrayList<Integer> getNums()
		{
			return nums;
		}
		public void gotNum(Integer num)
		{
			nums.remove(nums.indexOf(num));
		}
	}
	private class Row
	{		
		private ArrayList<Integer> nums = new ArrayList();
		
		public Row()
		{
			for (int i = 1; i < 10;i++)
				nums.add(i); 
		}
		public ArrayList<Integer> getNums()
		{
			return nums;
		}
		public void gotNum(Integer num)
		{
			nums.remove(nums.indexOf(num));
		}
	}

	private class Quadrant
	{
		private ArrayList<Integer> nums;
		private int x, y;
		public Quadrant(int tx, int ty)
		{
			x = tx/3;
			y = ty/3;
			nums = new ArrayList();
			
		}
		public ArrayList<Integer> getNums()
		{
			return nums;
		}
		public void gotNum(Integer num)
		{	
				nums.remove(nums.indexOf(num));
		}
	}
}